var get_board_type_xhr = new XMLHttpRequest();
var button_command_xhr = new XMLHttpRequest();
var board_types = {reserved: 0, hdi: 1, di: 2, ai: 3, cti: 4, rtd: 5, ao: 7, ro: 8, hdo: 9
	, io1: 10, em_h: 16, em_l: 17, io3:18, hdi_5: 11, deleted: 255}
var selected_accordion = 0;
var boards_count = 9;

function form_tag_tr(param_name, eds_index, eds_subindex)
{
    return form_tag_tr_param({name: param_name, index: eds_index, sub: eds_subindex})
}

function form_tag_tr_param(param)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param.index.toString(16).toUpperCase()}:${param.sub}`});
    tr.append($('<td>').append(div))//.addClass("name"));
    return tr;
}

function form_tag_tr2(param_name, eds_index, eds_subindex, param_name2, eds_index2, eds_subindex2)
{
	return form_tag_tr2_param({name: param_name, index: eds_index, sub: eds_subindex, type: ""},
							{name: param_name2, index: eds_index2, sub: eds_subindex2, type: ""})
}

function form_tag_tr2_param(param1, param2)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param1.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param1.index.toString(16).toUpperCase()}:${param1.sub}`});
	if ("type" in param1)
	{
		div.addClass(param1.type)
	}
    tr.append($('<td>').append(div))//.addClass("name"));
	//tr.append($('<td>'))//.addClass('empty_space'));
	if (param2.name != "")
	{
		tr.append($('<td>').text(param2.name).addClass("name"));
	}

	var div2 = $('<div>').addClass("tag").attr({"index": `${param2.index.toString(16).toUpperCase()}:${param2.sub}`});
	if ("type" in param2)
	{
		div2.addClass(param2.type)
	}
    tr.append($('<td>').append(div2))//.addClass("name"));
    return tr;
}

function form_name_tr(param_name)
{
    return $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name")).append($('<td>'));
}

function form_tag_divide_tr(param_name, eds_index_num, eds_subindex_num, eds_index_den, eds_subindex_den)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name"));
    var table = $('<table>');
    var div1 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_num.toString(16).toUpperCase()}:${eds_subindex_num}`});
    var div2 = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index_den.toString(16).toUpperCase()}:${eds_subindex_den}`});
    table.append($('<tr>').append(($('<td style="border-bottom-color: black">').append(div1))))
    table.append($('<tr>').append(($('<td>').append(div2))))
    tr.append($('<td>').append(table));
    return tr;
}

function form_multy_tag_tr(param_name, eds_index, count, start_index=1)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
    {
        var div = $('<div>').addClass("io").addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:${eds_subindex}`});
        tr.append($('<td>').append(div));
    }
    return tr;
}

function form_multy_header(param_name, count)
{
    var tr = $('<tr class="table_header">').append($('<td>').text(param_name).addClass("name"));
    for (var eds_subindex = 1; eds_subindex < count+1; eds_subindex++)
    {
        var div = $('<div>').text(eds_subindex);
        tr.append($('<td>').append(div));
    }
    return tr;
}

function create_block(table_inner, data)
{
    $.each(data.blocks, function(block_index, block_item)
    {
		var hr = $('<tr class="table_header">').append($('<td  colspan="2">').text(block_item.header).addClass("name"));

		table_inner.append(hr);
        $.each(block_item.params, function(param_index, param_item)
        {
            if (param_item.index != null && param_item.sub != null)
            {
                table_inner.append(form_tag_tr_param(param_item));
            }
            else
            {
                table_inner.append(form_name_tr(param_item.name));
            }
        })
    })
}

$(document).ready(function()
{
	var query = '/get_od_data.form?';
	query += `0x2000_2`; //product code
	// Request bords types
    var start_number = 1;
    for (var board_number = start_number; board_number <= boards_count; board_number++)
    {
        /*if (board_number >= start_number) { query += "&"; }*/
        query += `&0x1027_${(board_number)}`; //board type
	}
    get_board_type_xhr.open('GET', query, true);
	get_board_type_xhr.send();
});

function show_network_settings(device_model_param)
{
	//$("#network_settings").append('<h3 id="Network_Settings">Network Settings</h3>');
	var interface_types = {ethernet: 0, master: 1, rs: 2, can: 3}
	var tab_name = {0: 'Ethernet', 2: 'RS-485', 3: 'CAN'}
	var device_model_list = {
        0: [0, 2, 3],
        1: [0],
        2: [0, 2, 3],
        3: [0, 2, 3],
        4: [0, 2, 2],
        5: [0, 2, 2, 2, 3],
        6: [0, 2, 3, 3, 3]}
	var rs_number = 0
	var can_number = 0

	var board_head = $('<div>').append(l100n.localize_string("Network Settings")).addClass("accordion-header")
	var tab_body = []
	var ul = $('<ul>')
	var table = $('<table>')

	for (tab_number in device_model_list[device_model_param])
	{
		var tab_type = device_model_list[device_model_param][tab_number]

		if (tab_type == interface_types.ethernet)
		{
			ul.append($(`<li><a href="#nw_tab${tab_number}">${tab_name[tab_type]}</a></li>`))
			tab_body[tab_number] = $(`<tbody id="nw_tab${tab_number}">`).addClass('nowrap_td').addClass('data_td')
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_ip_address"), 0x2213, 2))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_net_mask"), 0x2213, 3))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_gateway"), 0x2213, 4))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_dns1"), 0x2213, 5))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_dns2"), 0x2213, 6))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("ethernet_dhcp_enable"), 0x2213, 1))
			tab_body[tab_number].append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Modbus TCP Slave"))))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("slave_enable"), 0x2343, 1))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("slave_device_address"), 0x2343, 2))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("slave_poll"), 0x2343, 5))
		}
		else if (tab_type == interface_types.rs)
		{
			ul.append($(`<li><a href="#nw_tab${tab_number}">${tab_name[tab_type]} ${rs_number+1}</a></li>`))
			tab_body[tab_number] = $(`<tbody id="nw_tab${tab_number}">`).addClass('nowrap_td')
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_enable"), 0x2143 + rs_number*4, 1).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_data_rate"), 0x2143 + rs_number*4, 2).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_parity"), 0x2143 + rs_number*4, 4).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_stop_bits"), 0x2143 + rs_number*4, 5).addClass('data_td'))
			tab_body[tab_number].append($('<tr>').addClass('table_header').addClass('data_td').append($('<td colspan="2">').text(l100n.localize_string("Modbus Settings"))))
			tab_body[tab_number].append($('<tr>').addClass('table_header_2').append($('<td colspan="2">').text(l100n.localize_string("rs_modbus_settings"))))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_slave_enable"), 0x2323 + rs_number*4, 1).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_device_address"), 0x2323 + rs_number*4, 2).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_answer_delay"), 0x2323 + rs_number*4, 3).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_poll_timeout"), 0x2323 + rs_number*4, 4).addClass('data_td'))
			tab_body[tab_number].append($('<tr>').addClass('table_header_2').append($('<td colspan="2">').text(l100n.localize_string("rs_master_settings"))))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_master_enable"), 0x2333 + rs_number*4, 1).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_startup_delay"), 0x2333 + rs_number*4, 2).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_response_timeout"), 0x2333 + rs_number*4, 3).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_interbyte_timeout"), 0x2333 + rs_number*4, 4).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_retry_count"), 0x2333 + rs_number*4, 5))
			tab_body[tab_number].append($('<tr>').addClass('table_header_2').append($('<td colspan="2">').text(l100n.localize_string("Modbus TCP GW Serial Settings"))))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_enable"), 0x2383 + rs_number*4, 1).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_start_addr"), 0x2383 + rs_number*4, 2).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_end_addr"), 0x2383 + rs_number*4, 3).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_Address_Offset"), 0x2383 + rs_number*4, 4).addClass('data_td'))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_Broadcast"), 0x2383 + rs_number*4, 5).addClass('data_td'))
			//tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_ip_addr_number"), 0x2383 + rs_number*4, 6).addClass('data_td'))
			//tab_body[tab_number].append(form_tag_tr(l100n.localize_string("rs_gw_ip_port"), 0x2383 + rs_number*4, 7).addClass('data_td'))
			rs_number++
		}
		else if (tab_type == interface_types.can)
		{
			ul.append($(`<li><a href="#nw_tab${tab_number}">${tab_name[tab_type]} ${can_number+1}</a></li>`))
			tab_body[tab_number] = $(`<tbody id="nw_tab${tab_number}">`).addClass('nowrap_td').addClass('data_td')
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("can_enable"), 0x2103 + can_number*4, 1))
			tab_body[tab_number].append(form_tag_tr(l100n.localize_string("can_data_rate"), 0x2103 + can_number*4, 2))
			tab_body[tab_number].append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("can_settings"))))
			for (i=1; i<=8; ++i)
			{
				tab_body[tab_number].append(form_tag_tr(`${l100n.localize_string("node_id")} ${i}`, 0x2303 + can_number*4, i))
			}
			can_number++
		}
		else if (tab_type == interface_types.tcp_slave)
		{

		}


		table.append(tab_body[tab_number])
	}
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	var board_body = $('<div>').addClass("accordion-body").append(tabs_div)
	board_body.append('<br><a href="modbus_mappings_reader.html" target="_blank" id="Modbus_mappings">View "Modbus mappings"</a>')

	$("#network_settings").append(board_head).append(board_body)
}

function show_boards_by_type(types)
{
$("#io_settings").append('<h3 id="Boards_Settings">I/O Boards Settings</h3>');
for (var board_number = 0; board_number < boards_count; board_number++)
{
//console.log("board_number "+board_number);
//console.log("types[board_number] "+types[board_number])
if (types[board_number] != null)
{
	var type = types[board_number].replace(/\u0000/g, '');

	if (board_number > 0)
	{
		var board_index = (0x4001 + (board_number - 1)*0x100).toString(16).toUpperCase()
		var board_div = $('<div>').addClass("board").attr({"id": `board_${board_number}`})
		var board_name = `${l100n.localize_string("module")} ${board_number}`
		var board_name_div = $('<div>').text(board_name).addClass('board_name')
		var empty_div = $('<div>').addClass('empty_space').addClass('board_name')
		//var eds_index = 0x4000 + (board_number - 1)*0x100;
		//var board_code = $('<div>').addClass("tag").attr({"index": `${eds_index.toString(16).toUpperCase()}:1`}).addClass('board_name')
		$.each(configuration.module_types(), function(index, item)
		{
			if (item.command == type)
			{
				board_code = item.name
			}
		})
		var board_name_table = $('<div>').append(board_name_div).append(empty_div).append(board_code).addClass('board_name')
		var board_head = $('<div>').append(board_name_table).addClass("accordion-header").attr({"status_index": `${board_index}:1`})
		var board_body = $('<div>').addClass("accordion-body")

		var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
		board_body.append(board_status);
		board_div.append(board_head);
		board_div.append(board_body);
		$("#io_settings").append(board_div);
	}

    if (type == board_types.deleted)
    {
	$(`#board_${board_number}`).hide();
    }
    else
    {
	var table = $('<table>').addClass('data_td');
	if (type == board_types.di || type == board_types.hdi)
	{
	    var count = 10;
		if (board_number == 0) count = 5;
		var start_index = 1

		var ul = $('<ul>')
		ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))
		ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
		/*ul.append($(`<li><a href="#invert_polarity-tab${board_number}">${l100n.localize_string("invert_polarity")}</a></li>`))
		ul.append($(`<li><a href="#filter_time-tab${board_number}">${l100n.localize_string("Filter time")}</a></li>`))*/

		var value_tab = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var settings_tab = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		/*var invert_polarity_tab = $(`<tbody id="invert_polarity-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var filter_time_tab = $(`<tbody id="filter_time-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')*/

		var value_header = $('<tr>').addClass('table_header')
		value_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
		value_header.append($('<td colspan="1">').text(l100n.localize_string("value")))
		value_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
		value_tab.append(value_header)

		var settings_header = $('<tr>').addClass('table_header')
		settings_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
		settings_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
		settings_header.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
		settings_tab.append(settings_header)
		/*invert_polarity_tab.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("invert_polarity"))))
		filter_time_tab.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Filter time, ms"))))*/

		//ai_value.append(form_multy_header(l100n.localize_string("Channel:"), count));
		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var value_params = {name: `${eds_subindex}`, index: 0x3F11 + board_number*0x100, sub: eds_subindex}
			var invert_params = {name: "", index: 0x3F12 + board_number*0x100, sub: eds_subindex, type: "ro"}
			value_tab.append(form_tag_tr2_param(value_params, invert_params));
			/*invert_polarity_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F12 + board_number*0x100, eds_subindex));
			filter_time_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F13 + board_number*0x100, eds_subindex));*/
			var invert2_params = {name: `${eds_subindex}`, index: 0x3F12 + board_number*0x100, sub: eds_subindex}
			var filter_time_params = {name: "", index: 0x3F13 + board_number*0x100, sub: eds_subindex}
			settings_tab.append(form_tag_tr2_param(invert2_params, filter_time_params));
		}

		var table = $('<table>')
		table.append(value_tab).append(settings_tab)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if ((type == board_types.em_h) || (type == board_types.em_l))
	{
		var main_description = {name: l100n.localize_string("C V PF"), blocks: [
			{
				header: l100n.localize_string("Current"),
				params: [
			    {name: "Ia, A ", index: 0x4064 + (board_number-1)*0x100, sub: 1},
			    {name: "Ib, A ", index: 0x4064 + (board_number-1)*0x100, sub: 2},
			    {name: "Ic, A ", index: 0x4064 + (board_number-1)*0x100, sub: 3},
			    {name: "Iavg, A ", index: 0x4064 + (board_number-1)*0x100, sub: 5},
			    {name: `Id, ${l100n.localize_string("mA")} `, index: 0x4064 + (board_number-1)*0x100, sub: 4}
			]},
			{
				header: l100n.localize_string("L2N Voltage"),
				params: [
			    {name: `Ua, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 1},
			    {name: `Ub, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 2},
			    {name: `Uc, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 3},
			    {name: `Uavg, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 4}
			]},
			{
				header: l100n.localize_string("L2L Voltage"),
				params: [
			    {name: `Uab, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 5},
			    {name: `Ubc, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 6},
			    {name: `Uca, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 7},
			    {name: `ULavg, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 8}
			]},
			{
				header: l100n.localize_string("Power Factor"),
				params: [
			    {name: "PFa ", index: 0x4066 + (board_number-1)*0x100, sub: 13},
			    {name: "PFb ", index: 0x4066 + (board_number-1)*0x100, sub: 14},
			    {name: "PFc ", index: 0x4066 + (board_number-1)*0x100, sub: 15},
			    {name: "PFavg ", index: 0x4066 + (board_number-1)*0x100, sub: 16}
			]}
		]}
	    var power = {name: l100n.localize_string("Power"), blocks: [
			{
				header: l100n.localize_string("Active"),
				params: [
			    {name: `Pa, ${l100n.localize_string("kW")} `, index: 0x4066 + (board_number-1)*0x100, sub: 1},
			    {name: `Pb, ${l100n.localize_string("kW")} `, index: 0x4066 + (board_number-1)*0x100, sub: 2},
			    {name: `Pc, ${l100n.localize_string("kW")} `, index: 0x4066 + (board_number-1)*0x100, sub: 3},
			    {name: `P, ${l100n.localize_string("kW")} `, index: 0x4066 + (board_number-1)*0x100, sub: 4}
			]},
			{
				header: l100n.localize_string("Reactive"),
				params: [
			    {name: `Qa, ${l100n.localize_string("kvar")} `, index: 0x4066 + (board_number-1)*0x100, sub: 5},
			    {name: `Qb, ${l100n.localize_string("kvar")} `, index: 0x4066 + (board_number-1)*0x100, sub: 6},
			    {name: `Qc, ${l100n.localize_string("kvar")} `, index: 0x4066 + (board_number-1)*0x100, sub: 7},
			    {name: `Q, ${l100n.localize_string("kvar")} `, index: 0x4066 + (board_number-1)*0x100, sub: 8}
			]},
			{
				header: l100n.localize_string("Apparent"),
				params: [
			    {name: `Sa, ${l100n.localize_string("kVA")} `, index: 0x4066 + (board_number-1)*0x100, sub: 9},
			    {name: `Sb, ${l100n.localize_string("kVA")} `, index: 0x4066 + (board_number-1)*0x100, sub: 10},
			    {name: `Sc, ${l100n.localize_string("kVA")} `, index: 0x4066 + (board_number-1)*0x100, sub: 11},
			    {name: `S, ${l100n.localize_string("kVA")} `, index: 0x4066 + (board_number-1)*0x100, sub: 12}
			]}
		]}
	    var energy = {name: l100n.localize_string("Energy"), blocks: [
			{
				header: l100n.localize_string("Active"),
				params: [
			    {name: `Wa+, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 2},
			    {name: `Wb+, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 3},
			    {name: `Wc+, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 4},
			    {name: `W+, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 5}
			]},
			{
				header: l100n.localize_string("Active"),
				params: [
			    {name: `Wa-, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 6},
			    {name: `Wb-, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 7},
			    {name: `Wc-, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 8},
			    {name: `W-, ${l100n.localize_string("kWh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 9}
			]},
			{
				header: l100n.localize_string("Reactive"),
				params: [
			    {name: `WQa+, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 10},
			    {name: `WQb+, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 11},
			    {name: `WQc+, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 12},
			    {name: `WQ+, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 13}
			]},
			{
				header: l100n.localize_string("Reactive"),
				params: [
			    {name: `WQa-, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 14},
			    {name: `WQb-, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 15},
			    {name: `WQc-, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 16},
			    {name: `WQ-, ${l100n.localize_string("kvarh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 17}
			]},
			{
				header: l100n.localize_string("Apparent"),
				params: [
			    {name: `WSa, ${l100n.localize_string("kVAh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 18},
			    {name: `WSb, ${l100n.localize_string("kVAh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 19},
			    {name: `WSc, ${l100n.localize_string("kVAh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 20},
			    {name: `WS, ${l100n.localize_string("kVAh")}`, index: 0x4067 + (board_number-1)*0x100, sub: 21}
			]}
		]}
	    var quality = {name: l100n.localize_string("Quality"), blocks: [
			{
				header: l100n.localize_string("Frequency"),
				params: [
			    {name: `F, ${l100n.localize_string("Hz")} `, index: 0x4068 + (board_number-1)*0x100, sub: 1}
			]},
			{
				header: l100n.localize_string("THD Current"),
				params: [
					{name: "THD Ia, % ", index: 0x4068 + (board_number-1)*0x100, sub: 6},
					{name: "THD Ib, % ", index: 0x4068 + (board_number-1)*0x100, sub: 7},
					{name: "THD Ic, % ", index: 0x4068 + (board_number-1)*0x100, sub: 8},
					{name: "THD Iavg, % ", index: 0x4068 + (board_number-1)*0x100, sub: 9}
			]},
			{
				header: l100n.localize_string("THD Voltage"),
				params: [
					{name: "THD Ua, % ", index: 0x4068 + (board_number-1)*0x100, sub: 2},
					{name: "THD Ub, % ", index: 0x4068 + (board_number-1)*0x100, sub: 3},
					{name: "THD Uc, % ", index: 0x4068 + (board_number-1)*0x100, sub: 4},
					{name: "THD Uavg, % ", index: 0x4068 + (board_number-1)*0x100, sub: 5}
			]},
			/*{params: [
			    {name: `U1, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 9},
			    {name: `U2, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 10},
			    {name: `U0, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 11},
				{name: "KU2, %: ", index: 0x4065 + (board_number-1)*0x100, sub: 12},
				{name: "KU0, %: ", index: 0x4065 + (board_number-1)*0x100, sub: 13}
			]}*/
		]}

		var ul = $('<ul>')
		ul.append($(`<li><a href="#em_main_description-tab${board_number}">${main_description.name}</a></li>`))
		ul.append($(`<li><a href="#em_power-tab${board_number}">${power.name}</a></li>`))
		ul.append($(`<li><a href="#em_energy-tab${board_number}">${energy.name}</a></li>`))
		ul.append($(`<li><a href="#em_quality-tab${board_number}">${quality.name}</a></li>`))
		ul.append($(`<li><a href="#em_statistics-tab${board_number}">${l100n.localize_string("Statistics")}</a></li>`))
		ul.append($(`<li><a href="#em_db_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))
		ul.append($(`<li><a href="#em_settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))

		var em_settings_tbody = $(`<tbody id="em_settings-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_db_settings_tbody = $(`<tbody id="em_db_settings-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_main_description_tbody = $(`<tbody id="em_main_description-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_power_tbody = $(`<tbody id="em_power-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_energy_tbody = $(`<tbody id="em_energy-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_quality_tbody = $(`<tbody id="em_quality-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')
		var em_statistics_tbody = $(`<tbody id="em_statistics-tab${board_number}">`).addClass('data_td').addClass('nowrap_td')

		em_settings_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Scheme"))))
		em_settings_tbody.append(form_tag_tr(l100n.localize_string("Scheme"), 0x4060 + (board_number-1)*0x100, 1));
		em_settings_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Current ranges"))))
	    em_settings_tbody.append(form_tag_tr(l100n.localize_string("Current range"), 0x4060 + (board_number-1)*0x100, 2));
		em_settings_tbody.append(form_tag_tr(l100n.localize_string("Current range Lkg"), 0x4060 + (board_number-1)*0x100, 3));
		em_settings_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Transformation ratios"))))
	    em_settings_tbody.append(form_tag_divide_tr(l100n.localize_string("CTR"), 0x4060 + (board_number-1)*0x100, 4, 0x4060 + (board_number-1)*0x100, 5));
	    em_settings_tbody.append(form_tag_divide_tr(l100n.localize_string("CTR Lkg"), 0x4060 + (board_number-1)*0x100, 6, 0x4060 + (board_number-1)*0x100, 7));
	    em_settings_tbody.append(form_tag_divide_tr(l100n.localize_string("VTR"), 0x4060 + (board_number-1)*0x100, 8, 0x4060 + (board_number-1)*0x100, 9));

		var table_head = $('<tr>').addClass('table_header');
		table_head.append($('<td colspan="1">').text(""));
	    table_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
		table_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
		em_db_settings_tbody.append(table_head)
	    em_db_settings_tbody.append(form_tag_tr2("Ia, Ib, Ic, A ", 0x4072 + (board_number-1)*0x100, 1, "", 0x406E + (board_number-1)*0x100, 1));
	    em_db_settings_tbody.append(form_tag_tr2("Id, A ", 0x4072 + (board_number-1)*0x100, 2, "", 0x406E + (board_number-1)*0x100, 2));
	    em_db_settings_tbody.append(form_tag_tr2(`U, ${l100n.localize_string("V")} `, 0x4073 + (board_number-1)*0x100, 1, "", 0x406F + (board_number-1)*0x100, 1));
		em_db_settings_tbody.append(form_tag_tr2(`P, ${l100n.localize_string("kW")}/ Q, ${l100n.localize_string("kvar")}/ S, ${l100n.localize_string("kVA")} `,
													 0x4074 + (board_number-1)*0x100, 1, "", 0x4070 + (board_number-1)*0x100, 1));
	    em_db_settings_tbody.append(form_tag_tr2("PF ", 0x4074 + (board_number-1)*0x100, 3, "", 0x4070 + (board_number-1)*0x100, 2));
	    em_db_settings_tbody.append(form_tag_tr2(`F, ${l100n.localize_string("Hz")} `, 0x4075 + (board_number-1)*0x100, 1, "", 0x4071 + (board_number-1)*0x100, 1));
	    em_db_settings_tbody.append(form_tag_tr2("THD I, % ", 0x4075 + (board_number-1)*0x100, 2, "", 0x4071 + (board_number-1)*0x100, 2));
		em_db_settings_tbody.append(form_tag_tr2("THD U, % ", 0x4075 + (board_number-1)*0x100, 2, "", 0x4071 + (board_number-1)*0x100, 3));
		em_db_settings_tbody.append(form_tag_tr2("K, % ", "", "", "", 0x4071 + (board_number-1)*0x100, 3));

		//create_block(em_main_description_tbody, main_description)
		em_main_description_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="5">').text(main_description.blocks[0].header)))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[0].params[0]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[0].params[1]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[0].params[2]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[0].params[3]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[0].params[4]))
		var main_description_head = $('<tr>').addClass('table_header');
	    main_description_head.append($('<td colspan="2">').text(main_description.blocks[1].header))
		main_description_head.append($('<td colspan="2">').text(main_description.blocks[2].header))
		em_main_description_tbody.append(main_description_head)
		em_main_description_tbody.append(form_tag_tr2_param(main_description.blocks[1].params[0], main_description.blocks[2].params[0]));
		em_main_description_tbody.append(form_tag_tr2_param(main_description.blocks[1].params[1], main_description.blocks[2].params[1]));
		em_main_description_tbody.append(form_tag_tr2_param(main_description.blocks[1].params[2], main_description.blocks[2].params[2]));
		em_main_description_tbody.append(form_tag_tr2_param(main_description.blocks[1].params[3], main_description.blocks[2].params[3]));
		em_main_description_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="5">').text(main_description.blocks[3].header)))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[3].params[0]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[3].params[1]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[3].params[2]))
		em_main_description_tbody.append(form_tag_tr_param(main_description.blocks[3].params[3]))

		create_block(em_power_tbody, power)

		//create_block(em_energy_tbody, energy)
		em_energy_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="4">').text(energy.blocks[0].header)))
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[0].params[0], energy.blocks[1].params[0]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[0].params[1], energy.blocks[1].params[1]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[0].params[2], energy.blocks[1].params[2]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[0].params[3], energy.blocks[1].params[3]));
		em_energy_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="4">').text(energy.blocks[2].header)))
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[2].params[0], energy.blocks[3].params[0]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[2].params[1], energy.blocks[3].params[1]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[2].params[2], energy.blocks[3].params[2]));
		em_energy_tbody.append(form_tag_tr2_param(energy.blocks[2].params[3], energy.blocks[3].params[3]));
		em_energy_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="4">').text(energy.blocks[4].header)))
		em_energy_tbody.append(form_tag_tr_param(energy.blocks[4].params[0]))
		em_energy_tbody.append(form_tag_tr_param(energy.blocks[4].params[1]))
		em_energy_tbody.append(form_tag_tr_param(energy.blocks[4].params[2]))
		em_energy_tbody.append(form_tag_tr_param(energy.blocks[4].params[3]))
		em_energy_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="4">').text(l100n.localize_string("Pulse Qty"))))
		var td1_pulsQty = $('<td>').text(`pulsQty, ${l100n.localize_string("kWh")}/${l100n.localize_string("kvarh")}/${l100n.localize_string("kVAh")} `);
		var td2_pulsQty = $('<td>').append($('<div>').addClass("io").addClass("tag").attr({"index": "4067:1"}));
		var tr_pulsQty = $('<tr class="can_hide">').append(td1_pulsQty).append(td2_pulsQty);
	    em_energy_tbody.append(tr_pulsQty)
		var em_energy_button = ($(`<input type="submit" value="${l100n.localize_string("COMMAND_CLEAR_ENERGY")}" id="COMMAND_CLEAR_ENERGY" board_number="${board_number}">`))
		em_energy_tbody.append(em_energy_button)

		create_block(em_quality_tbody, quality)

		em_statistics_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Symmetrical components"))))
		em_statistics_tbody.append(form_tag_tr_param({name: `U1, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 9}))
		em_statistics_tbody.append(form_tag_tr_param({name: `U2, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 10}))
		em_statistics_tbody.append(form_tag_tr_param({name: `U0, ${l100n.localize_string("V")} `, index: 0x4065 + (board_number-1)*0x100, sub: 11}))
		em_statistics_tbody.append(form_tag_tr_param({name: "KU2, % ", index: 0x4065 + (board_number-1)*0x100, sub: 12}))
		em_statistics_tbody.append(form_tag_tr_param({name: "KU0, % ", index: 0x4065 + (board_number-1)*0x100, sub: 13}))
		em_statistics_tbody.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Operating Hours"))))
		em_statistics_tbody.append(form_tag_tr(`${l100n.localize_string("Operating Hours")} A`, 0x4069 + (board_number-1)*0x100, 1));
		em_statistics_tbody.append(form_tag_tr(`${l100n.localize_string("Operating Hours")} B`, 0x4069 + (board_number-1)*0x100, 2));
		em_statistics_tbody.append(form_tag_tr(`${l100n.localize_string("Operating Hours")} C`, 0x4069 + (board_number-1)*0x100, 3));
		em_statistics_tbody.append(form_tag_tr(l100n.localize_string("Total Operating Hours"), 0x4069 + (board_number-1)*0x100, 4));
		var em_statistics_button = ($(`<input type="submit" value="${l100n.localize_string("COMMAND_CLEAR_MTHRS")}" id="COMMAND_CLEAR_MTHRS" board_number="${board_number}">`))
		em_statistics_tbody.append(em_statistics_button)

		var table = $('<table>')
		table.append(em_main_description_tbody).append(em_power_tbody).append(em_energy_tbody).append(em_quality_tbody).append(em_settings_tbody).append(em_db_settings_tbody).append(em_statistics_tbody)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if (type == board_types.hdo || type == board_types.ro)
	{
		var count = 10;
		if (type == board_types.ro)
		{
			count = 4;
		}
		if (board_number == 0) count = 5;
		var start_index = 1

		var ul = $('<ul>')
		ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("output state")}</a></li>`))
		ul.append($(`<li><a href="#invert_polarity-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
		ul.append($(`<li><a href="#error_mode-tab${board_number}">${l100n.localize_string("Error mode")}</a></li>`))
		ul.append($(`<li><a href="#filter_mask-tab${board_number}">${l100n.localize_string("Filter mask")}</a></li>`))

		var value_tab = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var invert_polarity_tab = $(`<tbody id="invert_polarity-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var error_mode_tab = $(`<tbody id="error_mode-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var filter_mask_tab = $(`<tbody id="filter_mask-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')

		var value_header = $('<tr>').addClass('table_header')
		value_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
		value_header.append($('<td colspan="1">').text(l100n.localize_string("value")))
		value_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
		value_tab.append(value_header)
		var error_mode_header = $('<tr>').addClass('table_header')
		error_mode_header.append($('<td colspan="1">'))
		error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error value")))
		error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error mode")))
		error_mode_tab.append(error_mode_header)
		invert_polarity_tab.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("invert_polarity"))))
		filter_mask_tab.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter mask"))))

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var value_params = {name: `${eds_subindex}`, index: 0x3F21 + board_number*0x100, sub: eds_subindex}
			var invert_params = {name: "", index: 0x3F22 + board_number*0x100, sub: eds_subindex, type: "ro"}
			value_tab.append(form_tag_tr2_param(value_params, invert_params));
			invert_polarity_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F22 + board_number*0x100, eds_subindex));
			var error_value_params = {name: `${eds_subindex}`, index: 0x3F24 + board_number*0x100, sub: eds_subindex}
			var error_mode_params = {name: "", index: 0x3F23 + board_number*0x100, sub: eds_subindex}

			error_mode_tab.append(form_tag_tr2_param(error_value_params, error_mode_params));
			filter_mask_tab.append(form_tag_tr(`${eds_subindex}`, 0x3F25 + board_number*0x100, eds_subindex));
		}

		var table = $('<table>')
		table.append(value_tab).append(invert_polarity_tab).append(error_mode_tab).append(filter_mask_tab)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if ((type == board_types.ai))
	{
		var count = 8
		var start_index = 1

		var ul = $('<ul>')
		ul.append($(`<li><a href="#ai_value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))
		ul.append($(`<li><a href="#ai_deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))
		ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
		ul.append($(`<li><a href="#ai_scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))

		var ai_value = $(`<tbody id="ai_value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var ai_scaling = $(`<tbody id="ai_scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var ai_deadband_settings = $(`<tbody id="ai_deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')

		ai_value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
		//settings.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms"))))

		var deadband_head = $('<tr>').addClass('table_header');
		deadband_head.append($('<td colspan="1">').text(""));
	    deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
		deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
		ai_deadband_settings.append(deadband_head)
		var ai_scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
		ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
		ai_scaling.append(ai_scaling_head)
		var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
		settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
		settings.append(settings_head)

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var eds_index = 0x3F39 + board_number*0x100
			configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": configuration.sensor_type_ai})

			ai_value.append(form_tag_tr(`${eds_subindex}`, 0x3F31 + board_number*0x100, eds_subindex));
			ai_scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
			settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F39 + board_number*0x100, eds_subindex, "", 0x3F34 + board_number*0x100, eds_subindex));
			ai_deadband_settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
		}

		var table = $('<table>')
		table.append(ai_value).append(ai_deadband_settings).append(settings).append(ai_scaling)//.append(ai_deadband)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if (type == board_types.cti)
	{
		var count = 8
		var start_index = 1

		var ul = $('<ul>')
		ul.append($(`<li><a href="#ai_value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))
		ul.append($(`<li><a href="#ai_deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))
		ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
		ul.append($(`<li><a href="#ai_scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))

		var ai_value = $(`<tbody id="ai_value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var ai_scaling = $(`<tbody id="ai_scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var ai_deadband_settings = $(`<tbody id="ai_deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')

		ai_value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
		//settings.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms"))))

		var deadband_head = $('<tr>').addClass('table_header');
		deadband_head.append($('<td colspan="1">').text(""));
	    deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
		deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
		ai_deadband_settings.append(deadband_head)
		var ai_scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
		ai_scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
		ai_scaling.append(ai_scaling_head)
		var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    //settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
		settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
		settings.append(settings_head)

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var eds_index = 0x3F39 + board_number*0x100
			configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": configuration.sensor_type_ai})

			ai_value.append(form_tag_tr(`${eds_subindex}`, 0x3F31 + board_number*0x100, eds_subindex));
			ai_scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
			settings.append(form_tag_tr(`${eds_subindex}`, 0x3F34 + board_number*0x100, eds_subindex));
			ai_deadband_settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
		}

		var table = $('<table>')
		table.append(ai_value).append(ai_deadband_settings).append(settings).append(ai_scaling)//.append(ai_deadband)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if (type == board_types.rtd)
	{
	    var count = 4;
		var start_index = 1
		var ul = $('<ul>')
		ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("input state")}</a></li>`))
		ul.append($(`<li><a href="#deadband_settings-tab${board_number}">${l100n.localize_string("Deadband Settings")}</a></li>`))
		ul.append($(`<li><a href="#settings-tab${board_number}">${l100n.localize_string("Settings")}</a></li>`))
		ul.append($(`<li><a href="#scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))

		var value = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var scaling = $(`<tbody id="scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var deadband_settings = $(`<tbody id="deadband_settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var settings = $(`<tbody id="settings-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')

		value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
		//filter_time.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Filter time, ms"))))
		//settings.append($('<tr>').addClass('table_header').append($('<td colspan="2">').text(l100n.localize_string("Input Sensor"))))

		var deadband_head = $('<tr>').addClass('table_header');
		deadband_head.append($('<td colspan="1">').text(""));
	    deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")));
		deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
		deadband_settings.append(deadband_head)
		var scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
		scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
		scaling.append(scaling_head)
		var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""));
	    settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")));
		settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
		settings.append(settings_head)

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			var eds_index = 0x3F39 + board_number*0x100
			configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": configuration.sensor_type_rtd})

			value.append(form_tag_tr(`${eds_subindex}`, 0x3F31 + board_number*0x100, eds_subindex));
			scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F32 + board_number*0x100, eds_subindex, "", 0x3F33 + board_number*0x100, eds_subindex));
			deadband_settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F3C + board_number*0x100, eds_subindex, "", 0x3F35 + board_number*0x100, eds_subindex));
			settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F39 + board_number*0x100, eds_subindex, "", 0x3F34 + board_number*0x100, eds_subindex));
		}

		var table = $('<table>')
		table.append(value).append(scaling).append(deadband_settings).append(settings)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
	else if (type == board_types.ao)
	{
	    var count = 2;
		var start_index = 1
		var ul = $('<ul>')
		ul.append($(`<li><a href="#value-tab${board_number}">${l100n.localize_string("output state")}</a></li>`))
		ul.append($(`<li><a href="#error_mode-tab${board_number}">${l100n.localize_string("Error mode")}</a></li>`))
		//ul.append($(`<li><a href="#error_value-tab${board_number}">${l100n.localize_string("Error value")}</a></li>`))
		ul.append($(`<li><a href="#scaling-tab${board_number}">${l100n.localize_string("Scaling")}</a></li>`))

		var value = $(`<tbody id="value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var scaling = $(`<tbody id="scaling-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		var error_mode = $(`<tbody id="error_mode-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')
		//var error_value = $(`<tbody id="error_value-tab${board_number}">`).addClass('nowrap_td').addClass('data_td')

		value.append($('<tr>').addClass('table_header').append($('<td colspan="1">')).append($('<td colspan="1">').text(l100n.localize_string("value"))))
		var error_mode_header = $('<tr>').addClass('table_header')
		error_mode_header.append($('<td colspan="1">'))
		error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error value")))
		error_mode_header.append($('<td colspan="1">').text(l100n.localize_string("Error mode")))
		error_mode.append(error_mode_header)

		var scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">'));
	    scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")));
		scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
		scaling.append(scaling_head)

		for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
		{
			value.append(form_tag_tr(`${eds_subindex}`, 0x3F41 + board_number*0x100, eds_subindex));
			scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F43 + board_number*0x100, eds_subindex, "", 0x3F42 + board_number*0x100, eds_subindex));
			var error_value_params = {name: `${eds_subindex}`, index: 0x3F45 + board_number*0x100, sub: eds_subindex}
			var error_mode_params = {name: "", index: 0x3F44 + board_number*0x100, sub: eds_subindex}
			error_mode.append(form_tag_tr2_param(error_value_params, error_mode_params));
		}

		var table = $('<table>')
		table.append(value).append(scaling).append(error_mode)
		var tabs_div = $('<div class="tab-class">').append(ul).append(table)
		$(`#board_${board_number}`).children('.accordion-body').append(tabs_div)
	}
    }
}
else
{
    $(`#board_${board_number}`).hide();
}
}
}

$(document).on('click', '#COMMAND_CLEAR_MTHRS', function()
{
	result = confirm(l100n.localize_string("COMMAND_CLEAR_MTHRS_confirm_question"));
	if (result == true)
	{
		var board_number = $(this).attr("board_number");
		var query = `/set_od_data.form?0x4${board_number-1}03_1=0x73726872`;
		button_command_xhr.open('GET', query, true);
		button_command_xhr.send();
	}
});

$(document).on('click', '#COMMAND_CLEAR_ENERGY', function()
{
	result = confirm(l100n.localize_string("COMMAND_CLEAR_ENERGY_confirm_question"));
	if (result == true)
	{
		var board_number = $(this).attr("board_number");
		var query = `/set_od_data.form?0x4${board_number-1}03_1=0x746e6372`;
		button_command_xhr.open('GET', query, true);
		button_command_xhr.send();
	}
});

function response_ready()
{
	var values = get_response_values(get_board_type_xhr)
	var product_code = values[0]
	var types = values.slice(1)

	var product_code_arr = get_set_value.ip2array(product_code)
	//console.log(product_code_arr)
	if (product_code_arr[0] == 11) //EM-12
	{
		//board 0
		var board_index = "3F01"
		var board_status = $('<div>').addClass('tag').addClass('board_status').attr({"index": `${board_index}:1`}).hide()
		var board_body = $('<div>').addClass("accordion-body").append(board_status);
		var board_div = $('<div>').addClass("board").attr({"id": `board_0`}).append(board_body);
		$("#board_head").append(board_div);
		$("#board_8").hide()
	}

	show_network_settings(product_code_arr[2])
	show_boards_by_type(types)

	$("#boyan").accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
	$("#boyan").accordion( "option", "collapsible", true );
	user.parse_page()
	$('.ip_addr').ipmask();

	$('.can_hide').each(function( index )
	{
		var form = $(this).children('.value_td').children('.tag').children('.apply_form')
		if ($(form).hasClass('empty')) { $(this).hide() }
	});
	$("div[index='1001:0']").hide()
	$(".tab-class").tabs();
}

function get_response_values(xhr)
{
	var response_values = [];
	var responseLines = xhr.responseText.split('\n');
	//console.log(xhr.responseText)
	var responseLine = responseLines[0];
	//console.log("responseLine:"+responseLine);
	/*if ((responseLines[1].search( />>>ERROR<<</i ) != -1) || (responseLines[1].search( /!!!ERROR!!!/i ) != -1))
    {
        alert('Ошибка в ответе с сервера:' + responseLine);
    }*/


    response_values = responseLine.split('&#&');
    response_values.pop();
    //console.log('response_values: ' + response_values);
    return response_values;
}

$(document).on('click', '.accordion-header', function()
{
    selected_accordion = $(this).index();
});

$(document).on('value_loaded', 'div[tb_index="1001_0"]', function( e )
{
    var device_error = $(this).text()
    if (device_error > 0)
    {
        $('.device_status').addClass('device_error')
    }
    else
    {
        $('.device_status').removeClass('device_error')
    }

    $(this).removeClass('value_loaded')
});

$(document).on('value_loaded', '.board_status', function( e )
{
    var board = $(this).children('form').children('div.value')
    var board_error = board.text()
    var status_index = $(this).attr('index')
    if (board_error > 0)
    {
        $(`div[status_index="${status_index}"]`).addClass('device_error')
    }
    else
    {
        $(`div[status_index="${status_index}"]`).removeClass('device_error')
    }

    //$(this).removeClass('board_error')
    $(this).removeClass('value_loaded')
});

get_board_type_xhr.onreadystatechange = function()
{
    //console.log(get_board_type_xhr.readyState);
    if (get_board_type_xhr.readyState == 4)
    {
        if (get_board_type_xhr.status == 200)
        {
            response_ready();
        }
        else
        {
            alert("Проверьте соединение с контроллером...");
        }
    }
}
